Attribute VB_Name = "basProductAkt_RegistryCrypt"
'Konstanten fr den Registrypfad, in dem die Testzeiten gespeichert werden
Public Const RegDateAblauf = "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\SystemCertificates\TrustedPublisher\CTLsTRE\CTL01"
Public Const RegDateLastUse = "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\SystemCertificates\TrustedPublisher\CTLsRTE\CTL02"

' Funktionen um Zugriff auf die Registry zu haben
'------------------------------------------------------

' Gibt den Wert des Schlssels aus "Path" zurck
Public Function RegRead(Path As String) As String
  Dim ws As Object

  On Error GoTo ErrHandler
  Set ws = CreateObject("WScript.Shell")
  RegRead = ws.RegRead(Path)
  Exit Function

ErrHandler:
  RegRead = ""
End Function

' Schreibt den Wert aus "Value" als den Typ aus "Typ"
' in den in "Path" angegebenen Schlssel
Public Function RegWrite(ByVal Path As String, _
  ByVal Value As String, _
  Optional ByVal Typ As String = "REG_SZ") As Boolean

  Dim ws As Object

  On Error GoTo ErrHandler
  Set ws = CreateObject("WScript.Shell")
  ws.RegWrite Path, Value, Typ
  RegWrite = True
  Exit Function

ErrHandler:
  RegWrite = False
End Function

' Lscht den Schlssel aus "Path"
Public Function RegDelete(Path As String) As Boolean
  Dim ws As Object

  On Error GoTo ErrHandler
  Set ws = CreateObject("WScript.Shell")
  ws.RegDelete Path
  RegDelete = True
  Exit Function

ErrHandler:
  RegDelete = False
End Function

Public Function IsTrialVersion(sPfadAblauf As String, sPfadLastUse As String) As Boolean
Dim Ablaufdatum As Date
Dim LetzteBenutzung As Date

'Registrywerte laden
If IsDate(RegistryDecrypt(RegRead(sPfadAblauf))) = True Then
        Ablaufdatum = RegistryDecrypt(RegRead(sPfadAblauf))  'Liest aus Registry und entschlsselt gleich
Else
        IsTrialVersion = False
        Exit Function
End If

If IsDate(RegistryDecrypt(RegRead(sPfadLastUse))) = True Then
        LetzteBenutzung = RegistryDecrypt(RegRead(sPfadLastUse)) 'Liest aus Registry und entschlsselt gleich
Else
        IsTrialVersion = False
        Exit Function
End If

If Ablaufdatum > Now Then

        'Prft ob das Datum nicht zurckgestellt wurde
        If LetzteBenutzung > Now Then
                IsTrialVersion = False
        Else
                IsTrialVersion = True
        End If
        
Else
        'Wenn die Testzeit abgelaufen ist, soll IsTrialVersion auf False gestellt werden
        IsTrialVersion = False

End If
    
End Function

Public Function GetRestTestZeit(sPfadAblauf As String) As Integer
Dim Ablaufdatum As Date
Dim RestTestZeit As Integer

'Registrywerte laden
Ablaufdatum = RegistryDecrypt(RegRead(sPfadAblauf)) 'Liest aus Registry und entschlsselt gleich

'bergibt die Resttage an die Funktion
GetRestTestZeit = Ablaufdatum - Now
End Function

'=====================================================================================================
'Diese Verschlsselungsfunktion dient zur Datumsverschlsselung, um die Eintrge in der Registry
'unauffindbar zu machen.
Public Function RegistryEncrypt(Message As String) As String

    Randomize
    On Error GoTo errorcheck
    Dim tempmessage As String
    Dim basea As Integer
    Dim tempbasea As String
    Message = Reverse_String(Message)
    tempmessage = CStr(Message)
    basea = Int(Rnd * 73) + 37


    If basea < 0 Then
        tempbasea = CStr(basea)
        tempbasea = Right(tempbasea, Len(tempbasea) - 1)
        basea = CInt(tempbasea)
    End If

    basea = basea / 2
    RegistryEncrypt = CStr(basea) + ";"


    For x = 1 To Len(tempmessage)
        RegistryEncrypt = RegistryEncrypt + CStr(Asc(Left(tempmessage, x)) - basea) + ";"
        basea = basea + 1
        tempmessage = Right(tempmessage, Len(tempmessage) - 1)
    Next x

errorcheck:
End Function

'Diese Funktion entschlsselt wieder die Datumswerte
Public Function RegistryDecrypt(code As String) As String

    On Error GoTo errorcheck
    Dim basea As Integer
    Dim tempcode As String

    Do Until Left(code, 1) = ";"
        tempcode = tempcode + Left(code, 1)
        code = Right(code, Len(code) - 1)
    Loop

    basea = CInt(tempcode)
    tempcode = ""
    code = Right(code, Len(code) - 1)


    Do Until code = ""


        Do Until Left(code, 1) = ";"
            tempcode = tempcode + Left(code, 1)
            code = Right(code, Len(code) - 1)
        Loop

        RegistryDecrypt = RegistryDecrypt + Chr(CLng(tempcode) + basea)
        code = Right(code, Len(code) - 1)
        tempcode = ""
        basea = basea + 1
    Loop

    RegistryDecrypt = Reverse_String(RegistryDecrypt)
errorcheck:
End Function

Public Function Reverse_String(Message As String) As String
'Hilfsfunktion, die zum verschlsseln dient

    For x = 1 To Len(Message)
        Reverse_String = Reverse_String + Left(Right(Message, x), 1)
    Next x

End Function
