Attribute VB_Name = "basProductAkt_WinVersion"
Option Explicit

' Zunchst die bentigten API-Deklarationen
Private Const VER_PLATFORM_WIN32s As Long = 0
Private Const VER_PLATFORM_WIN32_WINDOWS As Long = 1
Private Const VER_PLATFORM_WIN32_NT As Long = 2
Private Const VER_NT_SERVER As Long = &H3
Private Const VER_NT_WORKSTATION As Long = &H1
Private Const VER_SUITE_PERSONAL As Long = &H200
Private Const VER_SUITE_DATACENTER As Long = &H80
Private Const VER_SUITE_ENTERPRISE As Long = &H2

' der alte Standard
Private Type OSVERSIONINFO
  dwOSVersionInfoSize As Long
  dwMajorVersion As Long
  dwMinorVersion As Long
  dwBuildNumber As Long
  dwPlatformId As Long
  szCSDVersion As String * 128
End Type

' gibt's ab NT 4.0 mit SP6 (vgl. MSDN-Library)
Private Type OSVERSIONINFOEX
  dwOSVersionInfoSize As Long
  dwMajorVersion As Long
  dwMinorVersion As Long
  dwBuildNumber As Long
  dwPlatformId As Long
  szCSDVersion As String * 128
  wServicePackMajor As Integer
  wServicePackMinor As Integer
  wSuiteMask As Integer
  wProductType As Byte
  wReserved As Byte
End Type


' nicht Standard-Deklaration, sondern
' "lpVersionInformation As OSVERSIONINFOEX"!
Private Declare Function GetVersionEx Lib "kernel32" Alias _
  "GetVersionExA" ( _
 lpVersionInformation As OSVERSIONINFOEX) As Long
 
 ' Windows-Version bestimmen
Public Function GetWindowsVersion() As String
  Dim lRet As Long
  Dim VerInfo1 As OSVERSIONINFOEX    'neuer Datentyp
  Dim VerInfo2 As OSVERSIONINFO    'alter Datentyp

  On Error Resume Next

  ' hier wird die Gre des Datentyps festgelegt
  VerInfo1.dwOSVersionInfoSize = Len(VerInfo1)

  lRet = GetVersionEx(VerInfo1)
  If lRet = 0 Then
    ' wenn der erste Aufruf von GetVersionEx fehlgeschlagen
    ' hat, dann einfach die Gre des bergebenen
    ' Datentyps auf die des alten Typs ndern
    VerInfo1.dwOSVersionInfoSize = Len(VerInfo2)

    ' Versionsabfrage erneut aufrufen; wenn das auch
    ' schiefgeht, dann Funktion verlassen
    If GetVersionEx(VerInfo1) = 0 Then Exit Function
  End If

  ' jetzt kommt ein Wust von Prfungen; vgl. dazu auch wieder
  ' den entsprechenden Eintrag fr OSVERSIONINFOEX in der
  ' MSDN-Library
  With VerInfo1
    Select Case .dwPlatformId
      Case VER_PLATFORM_WIN32s
        GetWindowsVersion = "Win32s fr Windows 3.x"

      Case VER_PLATFORM_WIN32_WINDOWS
        Select Case .dwMinorVersion
          Case 0
            Select Case UCase(Trim(.szCSDVersion))
              Case "A"
                GetWindowsVersion = "Windows 95 A"
              Case "B", "C"
                GetWindowsVersion = "Windows 95 OSR2"
              Case Else
                GetWindowsVersion = "Windows 95"
            End Select

          Case 10
            Select Case UCase(Trim(.szCSDVersion))
              Case "A"
                GetWindowsVersion = "Windows 98 SE"
              Case Else
                GetWindowsVersion = "Windows 98"
            End Select

        Case 90
          GetWindowsVersion = "Windows ME"
        End Select

      Case VER_PLATFORM_WIN32_NT
        Select Case .dwMajorVersion
          Case 3
            GetWindowsVersion = "Windows NT 3." & CStr(.dwMinorVersion)

          Case 4
            If CInt(Right$(Trim(.szCSDVersion), 1)) >= 6 Then
              ' mindestens Service-Pack 6 installiert
              ' OSVERSIONINFOEX-Struktur kann komplett
              ' ausgewertet werden
              If .wProductType = VER_NT_WORKSTATION Then
                GetWindowsVersion = "Windows NT 4.0 Workstation"
              Else
                GetWindowsVersion = "Windows NT 4.0 Server"
              End If
            Else
              GetWindowsVersion = "Windows NT 4.0"
            End If

          Case 5
            Select Case .dwMinorVersion
              Case 0
                If .wProductType = VER_NT_WORKSTATION Then
                  GetWindowsVersion = "Windows 2000 Professional"
                Else
                  If (.wSuiteMask And VER_SUITE_ENTERPRISE) = VER_SUITE_ENTERPRISE Then
                    GetWindowsVersion = "Windows 2000 Advanced Server"
                  ElseIf (.wSuiteMask And VER_SUITE_DATACENTER) = VER_SUITE_DATACENTER Then
                    GetWindowsVersion = "Windows 2000 Datacenter Server"
                  Else
                    GetWindowsVersion = "Windows 2000 Server"
                  End If
                End If
              
              Case 1
                If .wProductType = VER_NT_WORKSTATION Then
                  If (.wSuiteMask And VER_SUITE_PERSONAL) = VER_SUITE_PERSONAL Then
                    GetWindowsVersion = "Windows XP Home Edition"
                  Else
                    GetWindowsVersion = "Windows XP Professional"
                  End If
                Else
                  GetWindowsVersion = "Neue, unbekannte Windows-Version"
                End If
              Case Else
                GetWindowsVersion = "Neue, unbekannte Windows-Version"
            End Select
          
          Case Else
            GetWindowsVersion = "Unbekannte Version"
        End Select
      Case Else
        GetWindowsVersion = "Unbekannte Version"
    End Select
  End With
End Function

Private Function Trim(ByVal InString As String) As String
  Trim = LTrim(RTrim(InString))
End Function

Public Function LTrim(ByVal InString As String) As String
  While InStr(Chr$(0) + Chr$(9) + Chr$(32), Left$(InString, 1)) > 0
    InString = Mid$(InString, 2)
  Wend
  LTrim = InString
End Function

Public Function RTrim(ByVal InString As String) As String
  While InStr(Chr$(0) + Chr$(9) + Chr$(32), Right$(InString, 1)) > 0
    InString = Left$(InString, Len(InString) - 1)
  Wend
  RTrim = InString
End Function

